#include "plconv.h"

main (int argc, char **argv)	{
//int ifd,ofd,j;
int j;
FILE * ifd, * ofd;
long i;
char iname [256], oname [256];
long readed,written;
char * it, * ot, *tmp, * rec = (char *) NULL;
char * buf = malloc(1);
if (argc<2) Usage (*argv);
strcpy(iname,"/dev/stdin"); // standardowo stdin, stdout
strcpy(oname,"/dev/stdout");
while ((i=getopt(argc, argv, "rf:i:o:p:"))!=EOF) {
	switch(i) {
		case 'f'	:
			strncpy (iname,optarg,256);
			break;
		case 'i'	:
			it = code + (opt2type(optarg)*18);
			break;
		case 'o' :
			ot = code + (opt2type(optarg)*18);
			break;
		case 'r' :
			recognize (iname);
			return 0;
		case 'p' :
			strncpy (oname,optarg,256);
			break;
		default :
			Usage (*argv);
			break;
		}
	}
	
if (!(ifd=fopen(iname,"r")))	{
	perror("Can't open file for reading");
	return 1;
	}

if (!(ofd=fopen (oname,"w")))	{
	perror("Can't open file for writting");
	return 1;
	}
while (readed=fread(buf,1,1,ifd))	{
	for (j=0;j<18;j++)
		if (*buf==*(it+j))	{
			*buf=*(ot+j);
			break;
			}
	fprintf (ofd,"%c",*buf);		
	}
fclose (ifd);
fclose (ofd);
return 0;
}

unsigned int opt2type (char * opt)	{
int i;
for (i=0;i<TYPES;i++)
	if (!strncmp(opt,types[i],20)) return i;
return 0;	
}

void recognize (char * iname)	{
int i , j;
unsigned long w [8];
FILE * ifd, * ofd;
unsigned int readed, temp=0, max=0;
unsigned char * buf = malloc (1);
for (i=0;i<8;i++) w[i]=0;

for (i=0;i<TYPES-1;i++)	w[i]=0;
if (!(ifd=fopen(iname,"r")))  {
	perror("Can't open file for reading");
	return;
	}
while (readed=fread(buf,1,1,ifd))   {
	for (i=0;i<TYPES-1;i++)	{  // sprawdza pokolei kazdy typ
		for (j=0;j<18;j++)	{	// kazdy znak o innym kodzie.
			if (*buf==*(code+(i*18)+j))   {
				w[i]++;
		   	continue;
				}
      	}
//		break;	
		}
	}	
fclose(ifd);
// znajduje najwiekszy :
for (i=0; i<TYPES-1;i++)
	{
//	printf("%s=%d\n",types[i],w[i]);
	if (w[i]>max) {
		max=w[i];
		temp=i;
		}
	}
printf("The guessed encoding is %s\nTry option -i %s while decoding.\n",types[temp],types[temp]);	
}

void Usage (char * name)	{
int i;
printf("PL Converter ver 1.1.2 by Pawel Prokop (pablo@wizard.ae.krakow.pl)\n\n");
printf("Usage : %s -i [type] -o [type] [-f input file] [-p output file]\n\n",name);
printf("  -i -o    Type of polish letters encoding. Currently supported are :\n           ");
for (i=0;i<TYPES;i++)	printf("%s ",types[i]);
printf("\n  -f       input file (if not set, reads data from stdin)");
printf("\n  -p       output file (if not set, writes data to stdout)\n\n");
exit(1);
}
